VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "agent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
  Dim referer As String
  Dim formdata As String
  Dim ie As Object
  Dim theHTML As String
  Dim ucaseHTML As String
  Dim pos As Long
  Dim region As String
  Dim HTTP As Object
  Public agentName As String
  Public studyURL As String
  
' These three documents are the ones I use to understand the IE object
' InternetExplorere object reference: http://msdn2.microsoft.com/en-us/library/Aa752084.aspx
' Document object recerence:          http://msdn2.microsoft.com/en-us/library/ms531073.aspx
' body object reference:              http://msdn2.microsoft.com/en-us/library/ms535205.aspx

Public Property Get visible() As Boolean
  If ie Is Nothing Then initializeIE
  visible = ie.visible
End Property

Public Property Let visible(theValue As Boolean)
  If ie Is Nothing Then initializeIE
  ie.visible = theValue
End Property




Sub openpage(url As String, Optional useIE As Boolean)
 If isMac Then
   updateHTML MacScript("return do shell script ""/usr/bin/curl -s -S -m 10 '" & url & "'""")
  
Else
  If useIE Then
    'opens the specified url in internet explorer
    If ie Is Nothing Then initializeIE
    ie.navigate url
    waitForLoad
    updateHTML
  Else
    
    If Not initializeHTTP Then Exit Sub
    
    HTTP.Open "GET", url, False
    HTTP.setRequestHeader "user-Agent", agentName & "(" & studyURL & ")"
    If Not ie Is Nothing Then HTTP.setRequestHeader "Cookie", ie.document.cookie
     If referer > "" Then HTTP.setRequestHeader "Referer", referer
    HTTP.Send
    updateHTML HTTP.responseText
  End If
End If
End Sub



Public Sub updateHTML(Optional theText As String)
  If theText > "" Then
    theHTML = theText
  Else
    theHTML = documentSourceIE()
  End If
  pos = 1
End Sub

Public Function documentSourceIE()
  Dim x As Long
  
  For x = 0 To ie.document.all.Length
    If ie.document.all(x).tagname = "HTML" Then
      documentSourceIE = ie.document.all(x).outerHTML
      Exit Function
    End If
  Next
End Function


Public Property Get Text() As String
  Text = theHTML
End Property

Public Property Let Text(theValue As String)
  theHTML = theValue
  ucaseHTML = ""
End Property

Public Property Get position() As Long
  position = pos
End Property

Public Property Let position(theValue As Long)
  pos = theValue
  If pos < 1 Then pos = 1
End Property

Public Property Get explorer() As Object
  Set explorer = ie
End Property

Public Property Get document() As Object
  Set document = ie.document
End Property

Sub initializeIE()
    'call this subprocedure to start internet explorer up
    Set ie = CreateObject("internetexplorer.application")
    pos = 1
End Sub

Sub terminateIE()
  ' call this subprocedure when you are finished with IE to close it down
  On Error Resume Next
  ie.Quit
  Set ie = Nothing
End Sub
Private Function initializeHTTP() As Boolean
    If agentName = "" Or studyURL = "" Then
      MsgBox "You must supply an agent name, and a study URL to use the non-visual data connection.  If your agent variable is ""agent1"", you can set these as follows: " & vbNewLine & vbNewLine & "agent1.studyURL=""http://my.server.edu/mystudy.html"" " & vbNewLine & "agent1.agentName=""AcademicResearchBot 1.2"" "
      Exit Function
    End If
    
    If HTTP Is Nothing Then
      Set HTTP = CreateObject("MSXML2.serverXMLHTTP")
    End If

    initializeHTTP = True

End Function
Sub saveFile(url As String, path As String)
' path is full path including filename
    strFileURL = url
    strHDLocation = path
 
' Fetch the file
    If Not initializeHTTP Then Exit Sub
 
    HTTP.Open "GET", strFileURL, False
    If Not ie Is Nothing Then HTTP.setRequestHeader "Cookie", ie.document.cookie
    HTTP.Send
 
    If HTTP.Status = 200 Then
      Set objADOStream = CreateObject("ADODB.Stream")
      objADOStream.Open
      objADOStream.Type = 1 'adTypeBinary
 
      objADOStream.Write HTTP.responsebody
      objADOStream.position = 0    'Set the stream position to the start
 
      Set objfso = CreateObject("Scripting.FileSystemObject")
        If objfso.fileexists(strHDLocation) Then objfso.DeleteFile strHDLocation
      Set objfso = Nothing
 
      objADOStream.SaveToFile strHDLocation
      objADOStream.Close
      Set objADOStream = Nothing
    End If
 


End Sub



Function multiReplace(ByVal expression As String, find As String, replacewith As String) As String
  'this function replaces multiple instances of a substing in a string with another string.
  ' it is helpful to change a arbitrary number of the same character to a single character
  ' such as converting all sequential spaces to a single space.
  
  Do While InStr(1, expression, find) > 0
    expression = Replace(expression, find, replacewith)
  Loop
  multiReplace = expression
End Function

Function removeWhiteSpace(theString) As String
Dim t As String
Dim x As Long
Dim onechar As String * 1
For x = 1 To Len(theString)
  onechar = Mid(theString, x, 1)
  If Asc(onechar) > 32 Then
    t = t & onechar
  Else
    t = t & " "
  End If
  
  Do While InStr(1, t, "  ") > 0
    t = Replace(t, "  ", " ")
  Loop
  
Next

removeWhiteSpace = t

End Function


Function replaceTags(theString As String, replaceTagsWith As String) As String
  ' this function replaces any HTML tags with the specified string.
  ' to remove tags, send a zero-length string as the second parameter
  
  Dim retval As String, dataon As Boolean, onechar As String, x As Long
  retval = ""
  dataon = True
  For x = 1 To Len(theString)
    onechar = Mid(theString, x, 1)
    If onechar = "<" Then
      retval = retval & replaceTagsWith
      dataon = False
    ElseIf onechar = ">" Then
      dataon = True
    ElseIf dataon Then
        retval = retval & onechar
    End If

  Next

  replaceTags = retval

End Function

Function getText(theString As String, Optional ignoreCase As Boolean) As String
Dim myPos As Long
  
  If ignoreCase Then
    If ucaseHTML = "" Then ucaseHTML = UCase(theHTML)
    myPos = InStr(pos, ucaseHTML, UCase(theString))
  Else
    myPos = InStr(pos, theHTML, theString)
  End If
  
  If myPos = 0 Then
    getText = ""
  Else
    getText = Mid(theHTML, pos, myPos - pos)
    pos = myPos + Len(theString)
  End If


End Function

Function moveTo(theString As String, Optional ignoreCase As Boolean, Optional ByVal theCount As Integer = 1) As Boolean
    Dim x As Integer
    moveTo = True
    For x = 1 To theCount
      If Not singleMoveTo(theString, ignoreCase) Then
         moveTo = False
         Exit Function
      End If
    Next
End Function

Private Function singleMoveTo(theString As String, Optional ignoreCase As Boolean) As Boolean
  Dim myPos As Long
  If ignoreCase Then
    If ucaseHTML = "" Then ucaseHTML = UCase(theHTML)
    myPos = InStr(pos, ucaseHTML, UCase(theString))
  Else
    myPos = InStr(pos, theHTML, theString)
  End If
  
  If myPos = 0 Then
    singleMoveTo = False
  Else
    singleMoveTo = True
    pos = myPos + Len(theString)
  End If

End Function
Function moveBackTo(theString As String) As Boolean
  Dim myPos As Long
  If ignoreCase Then
    If ucaseHTML = "" Then ucaseHTML = UCase(theHTML)
    myPos = InStrRev(ucaseHTML, UCase(theString), pos) + Len(theString)
  Else
    myPos = InStrRev(theHTML, theString, pos) + Len(theString)
  End If
  
  
    If myPos = Len(theString) Then
      moveBackTo = False
    Else
      pos = myPos
      moveBackTo = True
    End If

End Function


Function followLinkByText(theText As String, Optional exactMatch As Boolean = False) As Boolean
  'clicks the first link that has the specified text in the tag's inntertext
  Dim alink As Variant
  Dim found As Boolean
   
   For Each alink In ie.document.Links
     If exactMatch Then
       found = alink.innerhtml = theText
     Else
       found = InStr(1, alink.innerhtml, theText)
     End If
     If found Then
        alink.Click
        waitForLoad
        followLinkByText = True
        Exit Function
     End If
   Next
   
End Function
Function followLinkByHref(theText As String) As Boolean
  'clicks on the first links that has the specified URL

  Dim alink As Variant
  Dim found As Boolean
   
   For Each alink In ie.document.Links
     If exactMatch Then
       found = alink.href = theText
     Else
       found = InStr(1, alink.href, theText)
     End If
     If found Then
        alink.Click
        followLinkByHref = True
        waitForLoad
        Exit Function
     End If
   Next
   
End Function


Sub waitForLoad()
  'pauses the exection of the code until the webpage has loaded
  Do
    If Not ie.busy And ie.readystate = 4 Then
      Application.Wait (Now + TimeValue("00:00:02"))
         If Not ie.busy And ie.readystate = 4 Then
            Exit Do
          End If
    End If
    DoEvents
  Loop
  updateHTML

End Sub


Function readFile(path As String) As String
  ' returns the contents of a text file
  Open path For Input As #1
    readFile = Input(LOF(1), #1)
  Close #1
End Function
Sub savePage(Optional path As String, Optional Text As String)
   
  'saves the HTML of the current page to the specified path
  If path = "" Then
    Open ThisWorkbook.path & "\source.html" For Output As #1
  Else
    Open path For Output As #1
  End If
    If Text = "" Then
      If ie Is Nothing Then
        Print #1, theHTML
      Else
        Print #1, documentSourceIE
      End If
    Else
      Print #1, Text
    End If
  Close #1
End Sub

Private Sub Class_Initialize()
  agentName = "AcademicTeachingAgent 1.0"
  studyURL = "http://gove.net/academicTeachingAgent"
End Sub

Private Sub Class_Terminate()
  terminateIE
End Sub
Public Function attach(URL_of_IE_Window As String) As Boolean
  ' used to attach to an already open IE window.  Requires the url of hte window
  Set ie = get_IE_handle(URL_of_IE_Window)
  If Not ie Is Nothing Then
    attach = True
  End If
  updateHTML
End Function

Private Function get_IE_handle(URL_of_IE_Window As String) As Object
    Dim window As Object
    For Each window In CreateObject("Shell.application").Windows
      'Debug.Print window.LocationURL
      If InStr(1, window.LocationURL, URL_of_IE_Window) Then Exit For
    Next
    Set get_IE_handle = window
End Function

Public Sub execScript(javascript As String)
    ie.document.parentwindow.execScript (javascript)
    waitForLoad
End Sub
Public Sub importPage(newSheetName As String, Optional wb As Workbook)
  'this procedure saves a local copy of a web page that the agent
  'is viewing and uses excel's web query functionality to import
  'the data to a worksheet.
  
  Dim s As Worksheet
  
  If TypeName(wb) = "Nothing" Then
    Set wb = ThisWorkbook
  End If
  
  savePage ThisWorkbook.path & "\localWebPageAgentFile.html"
  
  On Error Resume Next
    Application.DisplayAlerts = False
       wb.Sheets(newSheetName).Delete
    Application.DisplayAlerts = True
  On Error GoTo 0
  
  
  Set s = wb.Worksheets.add
  s.name = newSheetName
  
      With s.QueryTables.add(Connection:= _
        "URL;file:///" & Replace(ThisWorkbook.path, "\", "/") & "/localWebPageAgentFile.html", Destination:=s.Range("$A$1"))
        .name = "localWebPageAgentFile"
        .FieldNames = True
        .RowNumbers = False
        .FillAdjacentFormulas = False
        .PreserveFormatting = True
        .RefreshOnFileOpen = False
        .BackgroundQuery = True
        .RefreshStyle = xlInsertDeleteCells
        .savePassword = False
        .SaveData = True
        .AdjustColumnWidth = True
        .RefreshPeriod = 0
        .WebSelectionType = xlEntirePage
        .WebFormatting = xlWebFormattingNone
        .WebPreFormattedTextToColumns = True
        .WebConsecutiveDelimitersAsOne = True
        .WebSingleBlockTextImport = False
        .WebDisableDateRecognition = False
        .WebDisableRedirections = False
        .Refresh BackgroundQuery:=False
    End With
    
    s.QueryTables(1).Delete
    
  Kill ThisWorkbook.path & "\localWebPageAgentFile.html"
  
  

End Sub



Sub showSource(Optional path As String, Optional Text As String)
  savePage path, Text
    
  If path = "" Then path = ThisWorkbook.path & "\source.html"
    
  Open ThisWorkbook.path & "\openpage.bat" For Output As #1
      Print #1, "start """" """ & path & """"
  Close #1
  
  ChDir ThisWorkbook.path
  
  Shell "openpage.bat"
End Sub


Function URLEncode(sRawURL As String) As String
 
     Dim iLoop
     Dim sRtn
     Dim sTmp
     Const sValidChars = "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz:/._-$(){}~"
 
 
     If Len(sRawURL) > 0 Then
         ' Loop through each char
 
         For iLoop = 1 To Len(sRawURL)
             sTmp = Mid(sRawURL, iLoop, 1)
 
 
             If InStr(1, sValidChars, sTmp, vbBinaryCompare) = 0 Then
                 ' If not ValidChar, convert to HEX and p
                 '     refix with %
                 sTmp = Hex(Asc(sTmp))
 
 
                 If sTmp = "20" Then
                     sTmp = "+"
                 ElseIf Len(sTmp) = 1 Then
                     sTmp = "%0" & sTmp
                 Else
                     sTmp = "%" & sTmp
                 End If
 
             End If
 
             sRtn = sRtn & sTmp
         Next
 
         URLEncode = sRtn
     End If
 'Debug.Print sRtn
 End Function

 
 
Public Function URLDecode(StringToDecode As String) As String

Dim TempAns As String
Dim CurChr As Integer

CurChr = 1

Do Until CurChr - 1 = Len(StringToDecode)
  Select Case Mid(StringToDecode, CurChr, 1)
    Case "+"
      TempAns = TempAns & " "
    Case "%"
      TempAns = TempAns & Chr(Val("&h" & _
         Mid(StringToDecode, CurChr + 1, 2)))
       CurChr = CurChr + 2
    Case Else
      TempAns = TempAns & Mid(StringToDecode, CurChr, 1)
  End Select

CurChr = CurChr + 1
Loop

URLDecode = TempAns
End Function
 
 Function HTMLDecode(ByVal html As String) As String
     Dim i As Long
     
     HTMLDecode = html
     
     Do
         ' search the next ampersand, exit if no more
         i = InStr(i + 1, HTMLDecode, "&")
         If i = 0 Then Exit Do
 

         If StrComp(Mid(HTMLDecode, i, 6), "&nbsp;", vbTextCompare) = 0 Then
            HTMLDecode = Left(HTMLDecode, i - 1) & " " & Mid(HTMLDecode, i + 6)
         ElseIf StrComp(Mid(HTMLDecode, i, 6), "&quot;", vbTextCompare) = 0 Then
             HTMLDecode = Left(HTMLDecode, i - 1) & """" & Mid(HTMLDecode, _
                 i + 6)
         ElseIf StrComp(Mid(HTMLDecode, i, 5), "&amp;", vbTextCompare) = 0 Then
             HTMLDecode = Left(HTMLDecode, i - 1) & "&" & Mid(HTMLDecode, _
                 i + 5)
         ElseIf StrComp(Mid(HTMLDecode, i, 4), "&lt;", vbTextCompare) = 0 Then
             HTMLDecode = Left(HTMLDecode, i - 1) & "<" & Mid(HTMLDecode, _
                 i + 4)
         ElseIf StrComp(Mid(HTMLDecode, i, 4), "&gt;", vbTextCompare) = 0 Then
             HTMLDecode = Left(HTMLDecode, i - 1) & ">" & Mid(HTMLDecode, _
                 i + 4)
         End If
     Loop
 End Function
 
 
 Function HTMLEncode(Text As String) As String
     Dim i As Long
     Dim acode As Byte
     Dim repl As String
 
     HTMLEncode = Text
 
     For i = Len(HTMLEncode) To 1 Step -1
         acode = Asc(Mid(HTMLEncode, i, 1))
         If acode = 32 Then
                 repl = "&nbsp;"
         ElseIf acode = 34 Then
                 repl = "&quot;"
         ElseIf acode = 38 Then
                 repl = "&amp;"
         ElseIf acode = 60 Then
                 repl = "&lt;"
         ElseIf acode = 62 Then
                 repl = "&gt;"
         ElseIf acode > 32 And acpde < 128 Then
                 ' don't touch alphanumeric chars
         Else
                 repl = "&#" & CStr(acode) & ";"
         End If
         If Len(repl) Then
             HTMLEncode = Left(HTMLEncode, i - 1) & repl & Mid(HTMLEncode, i + 1)
             repl = ""
         End If
     Next
 End Function



 Sub AddFormData(theName As String, ByVal theValue As String)
    If formdata > "" Then formdata = formdata & "&"
    formdata = formdata & theName & "=" & URLEncode(theValue)
  End Sub
 
 
 
 
  Sub clearFormData()
    formdata = ""
  End Sub
 
 Sub postdoc(theURL As String)
 
 
     pos = 1
     url = theURL
     If isMac Then
     
          updateHTML MacScript("return do shell script ""/usr/bin/curl -s -S -m 10 -d'" & formdata & "' '" & url & "'""")
     
     Else
         
         If Not initializeHTTP Then Exit Sub
         HTTP.Open "POST", theURL, False
         HTTP.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
    '     HTTP.setRequestHeader "From", from
         HTTP.setRequestHeader "User-Agent", agentName & "(" & studyURL & ")"
         If Not ie Is Nothing Then HTTP.setRequestHeader "Cookie", ie.document.cookie
         
         If referer > "" Then
           HTTP.setRequestHeader "Referer", referer
         End If
         
         HTTP.Send formdata
         theHTML = HTTP.responseText
     End If
     
   
   End Sub

Sub openpagemac(theURL As String)

Dim Text As String
Dim script As String
Dim currentURL As String

currentURL = theURL


script = "tell application" & Chr(34) & "Safari" & Chr(34) & Chr(13)
script = script & "activate" & Chr(13)
script = script & "set URL of document 1 to " & Chr(34) & currentURL & Chr(34) & Chr(13)
script = script & "delay 1" & Chr(13)
script = script & "repeat" & Chr(13)
script = script & "if (do JavaScript " & Chr(34) & "document.readyState" & Chr(34) & " in document 1) is " & Chr(34) & "complete" & Chr(34) & " then exit repeat" & Chr(13)
script = script & "delay 1" & Chr(13)
script = script & "end repeat" & Chr(13)
script = script & "return source of document 1" & Chr(13)
script = script & "end tell"

Text = MacScript(script)

updateHTML Text

End Sub


Function isMac() As Boolean
    If Application.OperatingSystem Like "*Mac*" Then
      isMac = True
    End If
End Function

